/*
 * This file is generated by jOOQ.
*/
package com.tabajara.base.tables;


import com.tabajara.base.Indexes;
import com.tabajara.base.Keys;
import com.tabajara.base.Public;
import com.tabajara.base.tables.records.SensorhorarepeticaoRecord;

import java.util.Arrays;
import java.util.List;

import javax.annotation.Generated;

import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Identity;
import org.jooq.Index;
import org.jooq.Name;
import org.jooq.Schema;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@Generated(
    value = {
        "http://www.jooq.org",
        "jOOQ version:3.10.5"
    },
    comments = "This class is generated by jOOQ"
)
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class Sensorhorarepeticao extends TableImpl<SensorhorarepeticaoRecord> {

    private static final long serialVersionUID = 64434563;

    /**
     * The reference instance of <code>public.sensorhorarepeticao</code>
     */
    public static final Sensorhorarepeticao SENSORHORAREPETICAO = new Sensorhorarepeticao();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<SensorhorarepeticaoRecord> getRecordType() {
        return SensorhorarepeticaoRecord.class;
    }

    /**
     * The column <code>public.sensorhorarepeticao.senhorid</code>.
     */
    public final TableField<SensorhorarepeticaoRecord, Integer> SENHORID = createField("senhorid", org.jooq.impl.SQLDataType.INTEGER.nullable(false).defaultValue(org.jooq.impl.DSL.field("nextval('sensorhorarepeticao_senhorid_seq'::regclass)", org.jooq.impl.SQLDataType.INTEGER)), this, "");

    /**
     * The column <code>public.sensorhorarepeticao.fksenid</code>.
     */
    public final TableField<SensorhorarepeticaoRecord, Integer> FKSENID = createField("fksenid", org.jooq.impl.SQLDataType.INTEGER, this, "");

    /**
     * The column <code>public.sensorhorarepeticao.fkhorid</code>.
     */
    public final TableField<SensorhorarepeticaoRecord, Integer> FKHORID = createField("fkhorid", org.jooq.impl.SQLDataType.INTEGER, this, "");

    /**
     * Create a <code>public.sensorhorarepeticao</code> table reference
     */
    public Sensorhorarepeticao() {
        this(DSL.name("sensorhorarepeticao"), null);
    }

    /**
     * Create an aliased <code>public.sensorhorarepeticao</code> table reference
     */
    public Sensorhorarepeticao(String alias) {
        this(DSL.name(alias), SENSORHORAREPETICAO);
    }

    /**
     * Create an aliased <code>public.sensorhorarepeticao</code> table reference
     */
    public Sensorhorarepeticao(Name alias) {
        this(alias, SENSORHORAREPETICAO);
    }

    private Sensorhorarepeticao(Name alias, Table<SensorhorarepeticaoRecord> aliased) {
        this(alias, aliased, null);
    }

    private Sensorhorarepeticao(Name alias, Table<SensorhorarepeticaoRecord> aliased, Field<?>[] parameters) {
        super(alias, null, aliased, parameters, "");
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Schema getSchema() {
        return Public.PUBLIC;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<Index> getIndexes() {
        return Arrays.<Index>asList(Indexes.SENSORHORAREPETICAO_PKEY);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Identity<SensorhorarepeticaoRecord, Integer> getIdentity() {
        return Keys.IDENTITY_SENSORHORAREPETICAO;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public UniqueKey<SensorhorarepeticaoRecord> getPrimaryKey() {
        return Keys.SENSORHORAREPETICAO_PKEY;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<UniqueKey<SensorhorarepeticaoRecord>> getKeys() {
        return Arrays.<UniqueKey<SensorhorarepeticaoRecord>>asList(Keys.SENSORHORAREPETICAO_PKEY);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<ForeignKey<SensorhorarepeticaoRecord, ?>> getReferences() {
        return Arrays.<ForeignKey<SensorhorarepeticaoRecord, ?>>asList(Keys.SENSORHORAREPETICAO__SENSORHORAREPETICAO_FKSENID_FKEY, Keys.SENSORHORAREPETICAO__SENSORHORAREPETICAO_FKHORID_FKEY);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Sensorhorarepeticao as(String alias) {
        return new Sensorhorarepeticao(DSL.name(alias), this);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Sensorhorarepeticao as(Name alias) {
        return new Sensorhorarepeticao(alias, this);
    }

    /**
     * Rename this table
     */
    @Override
    public Sensorhorarepeticao rename(String name) {
        return new Sensorhorarepeticao(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public Sensorhorarepeticao rename(Name name) {
        return new Sensorhorarepeticao(name, null);
    }
}
